import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class InvPowerPivot extends Frame
{  public int Iter;
   public InvPowerPivot()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [] MultMV(double [][] A,double [] B, int N1,int N2)
   {  int i,j,k;
      double [] C = new double[N1];
      for(i=0;i<N1;i++)
      {  C[i]=0.0;
         for(k=0;k<N2;k++) C[i] += A[i][k] * B[k];
      }
      return C;
   }
   public double [][] MultM(double [][] A,double [][] B, int N1,int N2,int N3)
   {  int i,j,k;
      double [][] C = new double[N1][N3];
      for(i = 0; i < N1; i++)for(j = 0; j < N3;j++)
      {  C[i][j]=0.0; for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public void MoveMat(double [][] A, double[][] B, int N, int COL)
   {
      int i,j;
      for(i = 0; i < N; i++)for(j=0; j<N; j++) B[i][j] = A[i][j + COL]; 
   }
   public int InvMat(double [][] A, int N, double Eps)
   {   int i,j,k; double Alfa;int N2 = N * 2;    
       for(i=0;i<N;i++)for(j=0;j<N;j++) A[i][j+N] = (i==j ? 1 : 0);
       for(k = 0; k < N; k++)       
       { if(Math.abs(A[k][k]) < Eps) return 1;
         Alfa=1/A[k][k];int k1=k+1;
         for(j=k1;j<N2;j++) A[k][j] *= Alfa;
         for(i=0;i<N;i++)
            if(i != k)
            { Alfa=A[i][k];
              for(j=k1;j<N2;j++) A[i][j] -= Alfa* A[k][j];
            }
       } 
       return 0;
   }

   public double [] MultSV(double A, double [] B, int N)
   {  int i,j,k;
      double [] C = new double[N];
      for(i = 0; i < N; i++) C[i] = A * B[i];
      return C;
   }
   public int LU_D_Pivot(double[][] A, double[][] LU,int [] Pivot,int N,double Eps)
   {  int i, j, k;
      MoveMat(A,LU,N,0); for(k=0;k<N;k++) Pivot[k]=k;
      for(k=0;k<N;k++)   // s{bgւ
      { i=k;
        for(j=k+1;j<N;j++) if(Math.abs(LU[Pivot[j]][k])>Math.abs(LU[Pivot[i]][k])) i=j;
        j = Pivot[k]; Pivot[k] = Pivot[i]; Pivot[i] = j;
        double PV = LU[Pivot[k]][k];
        if(Math.abs(PV)<Eps) return 1;
        for(i=k+1;i<N;i++)
        {  double T = LU[Pivot[i]][k] / PV; LU[Pivot[i]][k] = T;
           for(j=k+1;j<N;j++) LU[Pivot[i]][j] -= T * LU[Pivot[k]][j];
        }
      }
      return 0;
   }
   public double IgenValue(double [][] A, double[] X, int N)
   {  double lambda = 0; double T;
      int i,j, K1, K2, IterMax; double[][] XTemp = new double[2][N]; 
      K1 = 1; K2 = 0; IterMax = 100;
      double []   B      = new double[N];
      double [][] LU     = new double [N][N];
      int    []   Ipivot = new int [N];
              
      double EPS = 0.00001;
      int R = LU_D_Pivot(A, LU, Ipivot, N, EPS);
      if(R != 0) return 0.0;
      X[0] = 1; for(i = 1; i < N; i++) X[i]=0;
      Iter = 0; lambda = 1; double E = EPS * 100;
      while (E > EPS && Iter < IterMax)
      { Iter++;
        for(i = 0; i< N; i++)
        {  T = X[Ipivot[i]]; for(j = 0; j <= i - 1; j++) T -= LU[Ipivot[i]][j] * B[j];
           B[i] = T;
        }
        for(i = N - 1; i >= 0; i--)
        { T = B[i]; for(j = i + 1; j < N; j++) T -= LU[Ipivot[i]][j] * B[j];
          B[i] = T / LU[Ipivot[i]][i];
        }    
        T = 0; for(i = 0; i < N; i++) T += B[i] * B[i];
        lambda = Math.sqrt(T);
        if(lambda < EPS){  E = EPS * 100; break;}
        for(i = 0; i < N; i++)  X[i] = B[i] / lambda;
        double T1 = 0; double T2 = 0;
        for(i = 0; i < N; i++)
        {  double DX = X[i] - B[i]; T1 += DX * DX; T2 += X[i] * X[i];
        }
        if(Math.abs(T2) < EPS) {  E = EPS * 100; break;} // ŗLxNg0̂ƂȂ̂Ƃ
        E = T1 / T2;
     }
     return lambda;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN = 10 * Math.pow(10.0,(double)(N-1));
      double DX =  D * DN; if(Math.abs(DX)<0.5)return 0;
      return Math.rint(DX)/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A,int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<N; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
         }
      }
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      
   } 
   public void DrawMat(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,260,Y + 30);
      g.drawString( ope2,520,Y + 30);
      for(i=0;i<N1;i++)
      { for(j=0;j<N2; j++)
        { g.drawString( "" + round(A[i][j],3),  50 + j*50, Y + i*20);
          g.drawString( "" + round(B[i][j],3), 300 + j*50 , Y + i*20);
          g.drawString( "" + round(C[i][j],3), 550 + j*50 , Y + i*20);
        }
      }  
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      drawBra(g,290, Y - 10, 70); drawKet(g,490, Y - 10, 70);
      drawBra(g,540, Y - 10, 70); drawKet(g,740, Y - 10, 70);
   } 

   public void DrawMatVect(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [] B,double [] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,260,Y + 30);
      g.drawString( ope2,400,Y + 30);
      for(i=0;i<N1;i++)
      { for(j=0;j<N2; j++)g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
        g.drawString( "" + round(B[i],3),300, Y + i*20);
        g.drawString( "" + round(C[i],3),450, Y + i*20);
      }  
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      drawBra(g,290, Y - 10, 70); drawKet(g,350, Y - 10, 70);
      drawBra(g,440, Y - 10, 70); drawKet(g,490, Y - 10, 70);
   } 
   public void DrawScalerVect(Graphics g, String ope1,String ope2, int Y,
                       double A,double [] B,double [] C,int N)
   {  int i, j;
      g.drawString( ope1,260,Y + 30);
      g.drawString( ope2,400,Y + 30);
      g.drawString( ""+ round(A,3),200,Y + 30);
      for(i=0;i<N;i++)
      { g.drawString( "" + round(B[i],3),300, Y + i*20);
        g.drawString( "" + round(C[i],3),450, Y + i*20);
      }  
      //drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      drawBra(g,290, Y - 10, 70); drawKet(g,350, Y - 10, 70);
      drawBra(g,440, Y - 10, 70); drawKet(g,490, Y - 10, 70);
   } 

   public void paint(Graphics g)
   {  int i,j;
      double [][] A  = {{4,2,1,3},{2,3,1,2},{1,1,2,1},{3,2,1,1}};
      double []   B  = {0,0,0,0};
      double lambda = IgenValue(A, B, 4);
      setTitle("t@ɂŏŗLl(LUg@)");
      g.drawString( "f[^", 20, 50);
      DrawData(g, 80, A, 4);
      if(Math.abs(lambda)<0.000001) g.drawString( "ŗLl߂邱Ƃł܂", 20, 200);
      else
      {  lambda = 1 / lambda;
         g.drawString( "mF (JԂ : " + Iter + ")   = "+ lambda, 20, 200);
         double []    C = MultMV(A, B, 4, 4);
         DrawMatVect(g, "","", 240, A, B, C, 4,4);
         C = MultSV(lambda, B, 4);
         DrawScalerVect(g, "","", 340, lambda, B, C, 4);
      }
   } 
   public static void main(String[] args)
   {  Frame w = new InvPowerPivot();
      w.setVisible(true);
   }
}
